package com.example.fuzzControll.service.impl;

import com.example.fuzzControll.mapper.AflnetMapper;
import com.example.fuzzControll.mapper.KittyMapper;
import com.example.fuzzControll.mapper.MissionInfoMapper;
import com.example.fuzzControll.pojo.vo.AflnetResult;
import com.example.fuzzControll.pojo.vo.FuzzLogTransEntity;
import com.example.fuzzControll.pojo.vo.KittyResult;
import com.example.fuzzControll.pojo.vo.MissionInfo;
import com.example.fuzzControll.service.FuzzLogService;
import com.example.fuzzControll.tools.FileTools;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

@Slf4j
@Service("FuzzLogService")
public class FuzzLogServiceImpl implements FuzzLogService {
    @Autowired
    MissionInfoMapper missionInfoMapper;
    @Autowired
    AflnetMapper aflnetMapper;
    @Autowired
    KittyMapper kittyMapper;
    FileTools fileTools = new FileTools();

    @Override
    public FuzzLogTransEntity getFuzzLog(int missionId) throws IllegalAccessException {
        MissionInfo missionInfo = missionInfoMapper.selectByMissionId(missionId);
        if (missionInfo == null) {
            return null;
        }
        switch (missionInfo.getTableId()) {
            case 1:
                return downloadAflnetFile(missionInfo);
//           case 2:return downloadKittyProtocalFile(missionInfo);
            case 3:
                return downloadKittyOtherMethodFile(missionInfo);
            default:
                throw new IllegalAccessException("Invalid mission!");
        }
    }

    private FuzzLogTransEntity downloadKittyOtherMethodFile(MissionInfo missionInfo) {
        KittyResult kittyResult = kittyMapper.getKittyResultByMissionId(missionInfo.getMissionId());
        StringBuffer buffer = new StringBuffer();
        buffer.append(kittyResult.getResultError()).append(System.lineSeparator()).append(kittyResult.getResultOut());
        return new FuzzLogTransEntity(buffer.toString().getBytes(), missionInfo.getMissionName()+".txt");
    }

    private FuzzLogTransEntity downloadAflnetFile(MissionInfo missionInfo) {
        AflnetResult aflnetResult = aflnetMapper.selectResultById(missionInfo.getMissionId());
        return new FuzzLogTransEntity(aflnetResult.getFile(), aflnetResult.getFileName());
    }
}
